package com.bsoft.api.service.Impl;

import com.bsoft.api.common.utils.TokenUtil;
import com.bsoft.api.mapper.DicOrgMapper;
import com.bsoft.api.mapper.SysRoleMapper;
import com.bsoft.api.mapper.SysUserMapper;
import com.bsoft.api.model.DicOrg;
import com.bsoft.api.model.SerDepartment;
import com.bsoft.api.model.SysRole;
import com.bsoft.api.model.SysUser;
import com.bsoft.api.service.LoginService;
import com.bsoft.api.service.UserService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Date;
import java.util.List;


@Service
public class LoginServiceImpl implements LoginService {

    @Autowired
    private UserService userServiceImpl;

    @Resource
    private SysUserMapper sysUserMapper;
    @Resource
    private DicOrgMapper dicOrgMapper;
    @Resource
    private SysRoleMapper sysRoleMapper;

    @Override
    public LoginInfo login(String logName, String password, String ip) {

        LoginInfo loginInfo = new LoginInfo();

        SysUser user = userServiceImpl.findByLoginName(logName);
        if (user != null && user.getPassword().equals(password)) {
            String token = TokenUtil.getToken(password, user);
            //修改ip以及最后登录时间
            user.setLastIp(ip);
            user.setLastTime(new Date());
            sysUserMapper.updateByPrimaryKey(user);

            user.setPassword(null);
            loginInfo.setToken(token);
            loginInfo.setUser(user);

            //查询用户角色
            SysRole role = sysRoleMapper.selectByUser(user.getId());
            loginInfo.setRole(role);
            //查询用户机构
            List<DicOrg> orgList = dicOrgMapper.selectByUser(user.getId());
            if (orgList != null && orgList.size() > 0) {
                List<SerDepartment> deptList = dicOrgMapper.selectDeptByUser(user.getId(), orgList.get(0).getId());
                loginInfo.setDept(deptList != null && deptList.size() > 0 ? deptList.get(0) : null);
            }
            loginInfo.setOrg(orgList);
        }
        return loginInfo;
    }

    public String refreshToken(String oldToken) {
        return TokenUtil.refresh(oldToken);
    }
}
